property qChan, tFBaseChan, tfState1, tfState2, qList, points, answer, fCst, curQuest, nextWiggle, timeChunk, curState
global gCharScreenFlag, gCurrChar

on birth me, theQChan, theTFChan, theTimeChunk
  set fCst to the number of cast "TriviaQust.F1"
  set qChan to theQChan
  set tFBaseChan to theTFChan
  set timeChunk to theTimeChunk
  set nextWiggle to the timer + timeChunk
  set curState to 0
  setPuppets([qChan, tFBaseChan, tFBaseChan + 1, tFBaseChan + 2], 1)
  set qList to scramblesort(makeIdentityList(17))
  NextQuestion()
  return me
end

on NextQuestion me
  if count(qList) = 0 then
    set qList to scramblesort(makeIdentityList(17))
  end if
  set curQuest to GetOneDelete(qList)
  set the castNum of sprite qChan to curQuest + fCst
  if curQuest < 7 then
    set answer to 2
  else
    set answer to 1
  end if
  CheesyWipe()
  updateStage()
end

on Update me
  if the timer > nextWiggle then
    set curState to not curState
    set the castNum of sprite tFBaseChan to 378 + (curState * 5)
    set the castNum of sprite (tFBaseChan + 1) to the castNum of sprite tFBaseChan + 1
    set the castNum of sprite (tFBaseChan + 2) to the castNum of sprite tFBaseChan + 3
    set nextWiggle to the timer + timeChunk
  end if
end

on TrueClick me, theChan
  set the castNum of sprite theChan to the castNum of sprite theChan + 1
  puppetSnd("TFButtDn.AIF")
  updateStage()
  repeat while soundBusy(1)
  end repeat
  if answer = 1 then
    RightChoice(me)
  else
    WrongChoice(me)
  end if
  NextQuestion(me)
  FLUSH()
end

on FalseClick me, theChan
  set the castNum of sprite theChan to the castNum of sprite theChan + 1
  puppetSnd("TFButtDn.AIF")
  updateStage()
  repeat while soundBusy(1)
  end repeat
  if answer = 2 then
    RightChoice(me)
  else
    WrongChoice(me)
  end if
  NextQuestion(me)
  FLUSH()
end

on RightChoice me
  global gCharObj
  puppetSnd("TriviaRight.AIF")
  updateStage()
  repeat while soundBusy(1)
  end repeat
  puppetSnd("AudAppls.AIF")
  updateStage()
  addPoint(me)
  wait(60)
  repeat while soundBusy(1)
  end repeat
  if the frame > 50 then
    exit
  end if
  if random(5) > 4 then
    WinnerTalk(gCharObj)
  end if
end

on WrongChoice me
  global gCharObj
  puppetSnd("TriviaWrong.AIF")
  updateStage()
  repeat while soundBusy(1)
  end repeat
  LosePoint(me)
  puppetSnd("AudBoo.AIF")
  updateStage()
  wait(60)
  if random(5) > 4 then
    LoserTalk(gCharObj)
  end if
end

on addPoint me
  set the text of field "TriviaScore" to string(value(the text of field "TriviaScore") + 20)
  if value(the text of field "TriviaScore") > 100 then
    GoFrameVideo("TriviaVideo")
    return 1
  else
    return 0
  end if
end

on LosePoint me
  set the text of field "TriviaScore" to string(value(the text of field "TriviaScore") - 5)
  put "lsot point"
end

on Dispose me
  puppetSprite(chan, 0)
end
