property bChan, hChan, fHeadCst, fBodyCst, curState, nextWiggle, headCount, visibility, origIdleList, origloserList, origwinnerList, idleList, winnerList, loserList

on birth me, theBodyChan, theHeadChan, firstBody, firstHead, headnum, idle, win, lose
  set bChan to theBodyChan
  set hChan to theHeadChan
  set fBodyCst to firstBody
  set fHeadCst to firstHead
  set headCount to headnum
  set curState to 0
  set visibility to 0
  set origIdleList to idle
  set origwinnerList to win
  set origloserList to lose
  set idleList to scramblesort(origIdleList)
  set winnerList to scramblesort(origwinnerList)
  set loserList to scramblesort(origloserList)
  setPuppets([bChan, hChan], 1)
  return me
end

on Vanish me
  global gBlank
  set visibility to 0
  set the castNum of sprite bChan to gBlank
  set the castNum of sprite hChan to gBlank
end

on Appear me
  global gCurrChar
  set visibility to 1
  setPuppets([bChan, hChan], 1)
  if gCurrChar = 2 then
    set the ink of sprite hChan to 36
    set the ink of sprite bChan to 36
  else
    set the ink of sprite hChan to 8
    set the ink of sprite bChan to 8
  end if
  set nextWiggle to the timer + random(300)
  set the castNum of sprite bChan to fBodyCst
  set the castNum of sprite hChan to fHeadCst
end

on Update me
  if visibility = 0 then
    exit
  end if
  if the timer > nextWiggle then
    set the castNum of sprite hChan to fHeadCst + random(headCount) - 1
    set nextWiggle to the timer + random(300)
    if random(12) < 7 then
      talk(me)
    end if
  end if
end

on talk me, soundID
  global gCurrChar
  set sndPrefix to getAt(["HOWI", "DUSC", "PINKY", "JIVE", "MUCH", "HUMP"], gCurrChar)
  set done to 0
  if soundID < 10 then
    playSound(sndPrefix & "0" & soundID & ".AIF")
    DebugPrint("playing sound " & sndPrefix & "0" & soundID & ".AIF")
  else
    playSound(sndPrefix & soundID & ".AIF")
    DebugPrint("playing sound ", soundID & ".AIF")
  end if
  repeat while soundBusy(2)
    set theTime to the timer + 8 + random(6)
    SetSprite(hChan, fHeadCst + random(headCount) - 1)
    UStage(theTime)
    if the mouseDown then
      set exitFlag to 1
      sound stop 2
      exit repeat
    end if
  end repeat
  SetSprite(hChan, fHeadCst)
  updateStage()
end

on idleTalk me
  if count(idleList) = 0 then
    set idleList to scramblesort(origIdleList)
  end if
  set newDlg to GetOneDelete(idleList)
  talk(me, newDlg)
end

on LoserTalk me
  if count(loserList) = 0 then
    set loserList to scramblesort(origloserList)
  end if
  set newDlg to GetOneDelete(loserList)
  talk(me, newDlg)
end

on WinnerTalk me
  if count(winnerList) = 0 then
    set winnerList to scramblesort(origwinnerList)
  end if
  set newDlg to GetOneDelete(winnerList)
  talk(me, newDlg)
end
