property fChan, fCst, pieces, upChan, puzNum, points, curPuzzle, curState, pieceList, match, baseCst, puzzleList
global gCharScreenFlag, gCurrChar

on birth me, thefCst, thefChan, theupChan
  set fCst to thefCst
  set fChan to thefChan
  set pieces to 12
  set upChan to theupChan
  set puzNum to 5
  set curState to 0
  repeat with i = 1 to pieces
    set the puppet of sprite (fChan + i - 1) to 1
  end repeat
  set the puppet of sprite upChan to 1
  set puzzleList to scramblesort(makeIdentityList(puzNum))
  NewPuzzle()
  return me
end

on NewPuzzle me
  set pieceList to scramblesort(makeIdentityList(12))
  if count(puzzleList) = 0 then
    set puzzleList to scramblesort(makeIdentityList(puzNum))
  end if
  set curPuzzle to GetOneDelete(puzzleList)
  set baseCst to fCst + ((curPuzzle - 1) * 13)
  repeat with i = 1 to pieces
    set the castNum of sprite (fChan + i - 1) to baseCst + getAt(pieceList, i)
  end repeat
  CheesyWipe()
  updateStage()
end

on isMatch me
  set isMatch to 1
  repeat with i = 1 to pieces
    set curNum to baseCst + i
    if the castNum of sprite (fChan + i - 1) <> curNum then
      set isMatch to 0
      exit repeat
    end if
  end repeat
  return isMatch
end

on Fingered me, theclickOn, mH, mV
  global gBlank
  set pieceId to theclickOn - fChan + 1
  set dx to mH - the locH of sprite theclickOn
  set dy to mV - the locV of sprite theclickOn
  puppetSnd("SlideDrg.AIF")
  updateStage()
  set the castNum of sprite upChan to the castNum of sprite theclickOn
  set the castNum of sprite theclickOn to gBlank
  repeat while the mouseDown
    set the locH of sprite upChan to the mouseH - dx
    set the locV of sprite upChan to the mouseV - dy
    updateStage()
  end repeat
  set fmH to the mouseH
  set fmV to the mouseV
  set cols to [243, 348, 453, 557]
  set rows to [98, 205, 312]
  set closecol to 0
  set closecolDist to 1000
  repeat with i = 1 to 4
    set newDist to abs(fmH - getAt(cols, i))
    if newDist < closecolDist then
      set closecol to i
      set closecolDist to newDist
    end if
  end repeat
  set closerow to 0
  set closerowDist to 1000
  repeat with i = 1 to 3
    set newDist to abs(fmV - getAt(rows, i))
    if newDist < closerowDist then
      set closerow to i
      set closerowDist to newDist
    end if
  end repeat
  if (closecolDist > 50) or (closerowDist > 50) then
  end if
  set destSprite to (4 * (closerow - 1)) + closecol + fChan - 1
  set the castNum of sprite theclickOn to the castNum of sprite destSprite
  set the castNum of sprite destSprite to the castNum of sprite upChan
  set the castNum of sprite upChan to gBlank
  puppetSnd("SlideSnp.AIF")
  updateStage()
  if isMatch(me) then
    WinnerTalk(gCharObj)
    mPlayVideo(me)
    ResetTimer()
  end if
end

on mPlayVideo
  global lastPlace
  set lastPlace to marker(0)
  DissolveTransition()
  GoFrameVideo("ScrambleVideo")
end

on Update me
end
