property bChan, hChan, fHeadCst, fBodyCst, curState, nextWiggle, headCount, visibility, firstArm, armCount, introduced, armchan

on birth me, theBodyChan, theHeadChan, firstBody, firstHead, headnum, theArm, theArmCount
  set bChan to theBodyChan
  set hChan to theHeadChan
  set armchan to hChan + 1
  set fBodyCst to firstBody
  set fHeadCst to firstHead
  set headCount to headnum
  set curState to 0
  set visibility to 0
  set firstArm to theArm
  set armCount to theArmCount
  set introduced to [0, 0, 0, 0, 0, 0]
  setPuppets([bChan, hChan, armchan], 1)
  return me
end

on Vanish me
  global gBlank
  set visibility to 0
  set the castNum of sprite bChan to gBlank
  set the castNum of sprite hChan to gBlank
  set the castNum of sprite armchan to gBlank
end

on Appear me
  set visibility to 1
  setPuppets([bChan, hChan, armchan], 1)
  set nextWiggle to the timer + random(300)
  set the castNum of sprite bChan to fBodyCst
  set the castNum of sprite hChan to fHeadCst
  set the castNum of sprite armchan to firstArm
end

on Update me
  if visibility = 0 then
    exit
  end if
  if the timer > nextWiggle then
    set the castNum of sprite hChan to fHeadCst + random(headCount) - 1
    set nextWiggle to the timer + random(300)
    if random(12) < 7 then
      talk(me)
    end if
  end if
end

on introduceChar me
  global gCurrChar
  set appeared to getAt(introduced, gCurrChar)
  DebugPrint("appearedis " & appeared & " for " & gCurrChar)
  if not appeared then
    setAt(introduced, gCurrChar, 1)
    set dlg to "INTRO" & gCurrChar
    talk(me, dlg)
    set the castNum of sprite armchan to firstArm + 1
    updateStage()
  end if
end

on talk me, sndName
  global gCurrChar
  set done to 0
  DebugPrint("playing sound " & sndName & ".AIF")
  playSound(sndName & ".AIF")
  repeat while soundBusy(2)
    set theTime to the timer + 8 + random(6)
    SetSprite(hChan, fHeadCst + random(headCount) - 1)
    UStage(theTime)
    if the mouseDown then
      set exitFlag to 1
      sound stop 2
      exit repeat
    end if
  end repeat
  SetSprite(hChan, fHeadCst)
  updateStage()
end

on heckle me
end

on console me
end

on lewdremark me
  talk(me, "RDIDLE" & random(7))
end
