on InitGameSelect
  global gActiveList, gCurrChar, gActiveCast, aButtList, gRodneyObj, gCharObj
  set gActiveList to []
  set gActiveCast to [51, 54, 57, 60, 63]
  set aButtList to []
  add(aButtList, birth(script "UpButtons", 3, 51, 0, "NavMatching", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 4, 54, 0, "NavTrivia", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 5, 57, 0, "NavHangman", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 6, 60, 0, "NavScramble", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 7, 63, 0, "NavNewPlayer", "HILITE", "BUTTDN", "BUTTUP"))
  puppetSnd("GamSlct.AIF")
  updateStage()
  if objectp(gRodneyObj) then
    Appear(gRodneyObj)
  else
    playSound("RODINT" & random(2))
    set gRodneyObj to birth(script "Rodney", 32, 33, 397, 398, 10, 408, 1)
    add(gActiveList, gRodneyObj)
    Appear(gRodneyObj)
  end if
  WaitUntilQuietOrClick(2)
  sound stop 2
  puppetSnd("AudAppls.AIF")
  updateStage()
  wait(60)
  talk(gRodneyObj, "PREINT" & gCurrChar)
  introduceChar(gRodneyObj)
  CheesyWipe()
  if objectp(gCharObj) then
    Appear(gCharObj)
  else
    put "No charObj in InitGameSelect"
  end if
  updateStage()
  talk(gRodneyObj, "POSTINT" & gCurrChar)
  puppetSnd("AudBant.AIF")
end

on NavMatching
  alert("Too hot for you buddy")
end

on NavTrivia
  goFrame("Trivia")
end

on NavHangman
  alert("You're not hung enough for this one")
end

on NavScramble
  goFrame("Scramble")
end

on goFrame fName
  global activeList, gCharObj
  set activeList to []
  sound stop 1
  sound stop 2
  repeat with i = 1 to 48
    puppetSprite(i, 0)
  end repeat
  if objectp(gCharObj) then
    Vanish(gCharObj)
  else
    put "No charObjin goFrame"
  end if
  go(fName)
end

on NavNewPlayer
  global gMatchScreenFlag
  set gMatchScreenFlag to 0
  puppetSnd("NEWPLAYR.AIF")
  updateStage()
  repeat while soundBusy(1)
  end repeat
  setPuppets([8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25], 0)
  goFrame("CharSelect")
end

on initCharSelect
  global gActiveCast, aButtList, gCharScreenFlag, gCurrChar, gActiveList
  set gActiveCast to [74, 79, 84, 89, 94, 99, 104]
  set aButtList to []
  set gActiveList to []
  set gCurrChar to 0
  puppetSound(2, the number of cast "ShowLoop.AIF")
  add(aButtList, birth(script "UpButtons", 2, 74, 0, "mShowChar(getAt(aButtList,1),1)", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 3, 79, 0, "beep", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 4, 84, 0, "beep", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 5, 89, 0, "beep", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 6, 94, 0, "beep", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 7, 99, 0, "mShowChar(getAt(aButtList,6),6)", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 8, 104, 0, "NavGameSelect", "HILITE", "BUTTDN", "BUTTUP"))
  setPuppets([8, 10, 11, 12], 1)
  set gCharScreenFlag to 1
  if gCurrChar then
    mShowChar(getAt(aButtList, gCurrChar), gCurrChar)
  end if
end

on NavGameSelect
  global gCurrChar, gCharScreenFlag, gMatchScreenFlag, gCharObj
  if not gCurrChar and gCharScreenFlag then
    exit
  end if
  if gCharScreenFlag then
    set gCharScreenFlag to 0
  end if
  set gMatchScreenFlag to 0
  sfo(2, 30)
  puppetSnd("NEWGAME.AIF")
  updateStage()
  repeat while soundBusy(1)
  end repeat
  if objectp(gCharObj) then
    set gCharObj to 0
  end if
  if gCurrChar = 1 then
    set gCharObj to birth(script "Character", 30, 31, 429, 430, 6, [8, 9, 7], [1, 2, 4, 6, 8], [3, 4, 5, 10])
  else
    if gCurrChar = 2 then
      set gCharObj to birth(script "Character", 30, 31, 419, 421, 8, [6, 8], [1, 2, 3, 7], [4, 5, 9])
    else
      if gCurrChar = 3 then
        set gCharObj to birth(script "Character", 30, 31, 446, 448, 7, [3, 10, 9], [1, 2, 3, 4, 5, 6, 10, 11], [7, 8, 3])
      else
        if gCurrChar = 4 then
          set gCharObj to birth(script "Character", 30, 31, 436, 437, 5, [8, 6, 7], [1, 2, 8], [3, 4, 5, 9])
        else
          if gCurrChar = 5 then
            set gCharObj to birth(script "Character", 30, 31, 442, 443, 3, [2, 8, 3], [1, 2, 7], [4, 5, 6, 9])
          else
            if gCurrChar = 6 then
              set gCharObj to birth(script "Character", 30, 31, 410, 412, 7, [1, 3, 9, 5, 6, 12, 13], [1, 2, 7, 8], [3, 4, 8, 10])
            end if
          end if
        end if
      end if
    end if
  end if
  add(gActiveList, gCharObj)
  setPuppets([8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25], 0)
  goFrame("GameSelect")
end

on UpdateCharScreen
  global gCurrChar
  if gCurrChar and (the timer > 15) then
    startTimer()
    set currCast to the castNum of sprite 8
    if currCast = 104 then
      set the castNum of sprite 8 to currCast + 1
    else
      set the castNum of sprite 8 to currCast - 1
    end if
  end if
end

on Replay
  puppetSnd("REPLAY.AIF")
  updateStage()
  go(the frame - 1)
end

on initMatching
  global gfMatchCst, gTotalMatchCst, gMatchCurrList, gMatchAvailList, gMatchHotList, gSlotList, gLastUpdate, gMatchScreenFlag, gActiveCast, aButtList, gCharObj
  set gActiveCast to [178, 181, 184]
  set aButtList to []
  add(aButtList, birth(script "UpButtons", 3, 178, 0, "NavNewPlayer", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 4, 181, 0, "Replay", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 5, 184, 0, "NavGameSelect", "HILITE", "BUTTDN", "BUTTUP"))
  set gLastUpdate to the timer
  set gMatchCurrList to []
  set gMatchAvailList to []
  set gMatchHotList to []
  repeat with i = 1 to gTotalMatchCst
    add(gMatchAvailList, i + gfMatchCst - 1)
  end repeat
  set gMatchSelect to [0, 0, 0]
  set gSlotList to [10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25]
  set gMatchScreenFlag to 1
  setPuppets(gSlotList, 1)
  setPuppets([8, 9], 1)
  repeat with i = 1 to 15
    set pickIndex to random(count(gMatchAvailList))
    add(gMatchCurrList, getAt(gMatchAvailList, pickIndex))
    deleteAt(gMatchAvailList, pickIndex)
  end repeat
  set slotIndex to random(count(gSlotList))
  setAt(gMatchHotList, 1, getAt(gSlotList, slotIndex))
  deleteAt(gSlotList, slotIndex)
  set the castNum of sprite getAt(gMatchHotList, 1) to getAt(gMatchCurrList, 1)
  set slotIndex to random(count(gSlotList))
  setAt(gMatchHotList, 2, getAt(gSlotList, slotIndex))
  deleteAt(gSlotList, slotIndex)
  set the castNum of sprite getAt(gMatchHotList, 2) to getAt(gMatchCurrList, 1)
  repeat with i = 1 to 14
    set the castNum of sprite getAt(gSlotList, i) to getAt(gMatchCurrList, i + 1)
  end repeat
  if objectp(gCharObj) then
    Appear(gCharObj)
  else
    put "no charobj in matching"
  end if
  updateStage()
end

on SetGlobalButtons
  global gActiveCast, aButtList
  set gActiveCast to [178, 181, 184]
  set aButtList to []
  add(aButtList, birth(script "UpButtons", 3, 178, 0, "NavNewPlayer", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 4, 181, 0, "Replay", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 5, 184, 0, "NavGameSelect", "HILITE", "BUTTDN", "BUTTUP"))
end

on initTrivia
  global gActiveList, gLastUpdate, gTimerObj, gTrivia, gCharObj
  SetGlobalButtons()
  set gLastUpdate to the timer
  set gTrueFalseSprites to [10, 11, 12, 13]
  set gChars to [30, 31]
  setPuppets(gTrueFalseSprites, 1)
  set gActiveList to []
  puppetSprite(32, 1)
  set gTimerObj to birth(script "timer", 32, the number of cast "Timer.0", "TriviaTimeOut", "ClockTk1.AIF", 12.5 * 60)
  set the text of cast "TriviaScore" to "0"
  add(gActiveList, gTimerObj)
  set gTrivia to birth(script "TriviaManager", 10, 11, 24)
  add(gActiveList, gTrivia)
  Appear(gCharObj)
  ResetEvents()
end

on InitScramble
  global gActiveList, gActiveCast, aButtList, gLastUpdate, gTimerObj, gScramble, gCharObj, gCurrChar
  set gActiveCast to [178, 181, 184]
  set aButtList to []
  add(aButtList, birth(script "UpButtons", 3, 178, 0, "NavNewPlayer", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 4, 181, 0, "NewPuzzle(gScramble)", "HILITE", "BUTTDN", "BUTTUP"))
  add(aButtList, birth(script "UpButtons", 5, 184, 0, "NavGameSelect", "HILITE", "BUTTDN", "BUTTUP"))
  set gLastUpdate to the timer
  set gActiveList to []
  set gTimerObj to birth(script "timer", 32, the number of cast "Timer.0", "TriviaTimeOut", "ClockTk1.AIF", 6 * 60)
  add(gActiveList, gTimerObj)
  set gScramble to birth(script "Scrambler", 851, 10, 22)
  add(gActiveList, gScramble)
  add(gActiveList, gCharObj)
  Appear(gCharObj)
  ResetEvents()
end

on initHangMan
  global gActiveList, gLastUpdate, gTimerObj, ghangmanobj, gCharObj, gCurrChar
  SetGlobalButtons()
  set gLastUpdate to the timer
  set gActiveList to []
  set ghangmanobj to birth(script "HangMan", 17, 18, 19, 634, 654, 30)
  add(gActiveList, ghangmanobj)
  GetWord(ghangmanobj, 8)
end

on GrabMe theclickOn
  global gScramble
  Fingered(gScramble, theclickOn, the mouseH, the mouseV)
end

on updateActive
  global gActiveList
  if count(gActiveList) = 0 then
    exit
  end if
  repeat with obj in gActiveList
    Update(obj)
  end repeat
end

on TriviaTimeOut
  global gCharObj, gTimerObj
  LoserTalk(gCharObj)
  ResetTimer(gTimerObj)
end

on ResetTimer
  global gTimerObj
  if objectp(gTimerObj) then
    Reset(gTimerObj)
  else
    put "ERROR: no timer obj in frame " & the frame
  end if
end

on ParseHangClick mH, mV
  global ghangmanobj
  ParseClick(ghangmanobj, mH, mV)
end
