property chan, fCst, doScript, downSnd, upSnd, rollSnd, rollList
global gCharScreenFlag, gCurrChar, gMatchScreenFlag

on birth me, theChan, thefCst, theRList, theScript, theRollSnd, theDownSnd, theUpSnd
  set chan to theChan
  set fCst to thefCst
  set doScript to theScript
  set rollSnd to theRollSnd
  set downSnd to theDownSnd
  set upSnd to theUpSnd
  set rollList to theRList
  return me
end

on RollButt me
  if the castNum of sprite chan <> (fCst + 1) then
    set the castNum of sprite chan to fCst + 1
    if rollList <> 0 then
      set theCount to count(rollList)
      repeat with zPos = 1 to theCount
        set the castNum of sprite getPropAt(rollList, zPos) to getAt(getAt(rollList, zPos), 2)
      end repeat
    end if
    updateStage()
  end if
  repeat while rollOver(chan) and (the mouseCast = (fCst + 1))
    if the mouseDown then
      ButtDown(me)
      exit
    end if
    updateActive()
    if gCharScreenFlag and (fCst <> 104) then
      UpdateCharScreen()
    end if
    if gMatchScreenFlag then
      updateMatch()
    end if
    updateStage()
  end repeat
  set the castNum of sprite chan to fCst
  set mCast to the mouseCast
  if not getPos(gActiveCast, mCast) then
    if rollList <> 0 then
      set theCount to count(rollList)
      repeat with zPos = 1 to theCount
        set the castNum of sprite getPropAt(rollList, zPos) to getAt(getAt(rollList, zPos), 1)
      end repeat
    end if
  end if
  updateStage()
end

on ButtDown me
  set the castNum of sprite chan to fCst + 2
  puppetSnd(downSnd)
  updateStage()
  repeat while the mouseDown
    if rollOver(chan) then
      if the castNum of sprite chan <> (fCst + 2) then
        set the castNum of sprite chan to fCst + 2
        puppetSnd(downSnd)
      end if
    else
      if the castNum of sprite chan <> fCst then
        set the castNum of sprite chan to fCst
        puppetSnd(upSnd)
      end if
    end if
    updateStage()
  end repeat
  repeat while soundBusy(1)
  end repeat
  if the castNum of sprite chan = (fCst + 2) then
    if rollOver(chan) then
      set the castNum of sprite chan to fCst + 1
    else
      set the castNum of sprite chan to fCst
    end if
    puppetSnd(upSnd)
    updateStage()
    repeat while soundBusy(1)
    end repeat
    do(doScript)
    if rollOver(chan) then
      set the castNum of sprite chan to fCst + 1
      if rollList <> 0 then
        set theCount to count(rollList)
        repeat with zPos = 1 to theCount
          set the castNum of sprite getPropAt(rollList, zPos) to getAt(getAt(rollList, zPos), 2)
        end repeat
      end if
      updateStage()
    end if
  else
  end if
  FLUSH()
end

on mShowChar me, charNum
  global gBlnk
  set slctPrefix to getAt(["HOWSLCT", "DUCSLCT", "PNKSLCT", "JIVSLCT", "MUCSLCT", "HMPSLCT"], charNum)
  set fMouthList to getAt([[114, 4, 6], [118, 3, 6], [121, 4, 6], [125, 4, 4], [129, 3, 6], [132, 4, 4]], charNum)
  set fMouth to getAt(fMouthList, 1)
  set fMouthNum to getAt(fMouthList, 2)
  set sndNum to getAt(fMouthList, 3)
  set done to 0
  repeat with i = 1 to sndNum
    playSound(slctPrefix & i & ".AIF")
    set the castNum of sprite 10 to fCst + 3
    set the castNum of sprite 11 to fCst + 4
    updateStage()
    set gCurrChar to charNum
    repeat while soundBusy(2)
      if the mouseDown then
        set done to 1
        exit repeat
      end if
      set endT to the timer + 5 + random(12)
      set curMouth to random(fMouthNum + 1) - 1
      if not curMouth then
        set curMouth to gBlnk
      else
        set curMouth to fMouth + curMouth - 1
      end if
      set the castNum of sprite 12 to curMouth
      updateStage()
      repeat while the timer < endT
      end repeat
    end repeat
    set the castNum of sprite 10 to fCst + 3
    set the castNum of sprite 11 to fCst + 4
    updateStage()
    if done then
      exit repeat
    end if
    set endT to the timer + 5 + random(7)
    repeat while the timer < endT
    end repeat
  end repeat
end
